/**
 * Inspiration:https://greasyfork.org/zh-CN/scripts/421412
 * Author:KirisakiAria
 */
; (async function () {
    const default_input_url = 'https://github1s.com';
    const default_button_title = 'Github1s';
    const default_button_title_color = '#ffffff';
    const default_button_background_color = '#2ea44f';
    const default_new_table = 1;
    const default_right_menu = 0;
    const default_is_private = 1;
    const default_gitpod_url = 'https://gitpod.io/';
    const default_use_gitpod = 0;

    let input_url = await asyncGetItem('input_url');
    let button_title = await asyncGetItem('button_title');
    let button_title_color = await asyncGetItem('button_title_color');
    let button_background_color = await asyncGetItem('button_background_color');
    let new_tab = await asyncGetItem('new_tab');
    let right_menu = await asyncGetItem('right_menu');
    let is_private = await asyncGetItem('is_private');
    let private_elem = $('#js-repo-pjax-container .Label');
    let use_gitpod = await asyncGetItem('use_gitpod');

    var judge_is_private;

    if (private_elem.length) {

        private_elem.each(function (index, elem) {

            let elem_text = $.trim($(this).text());
            if (elem_text.toLowerCase() == 'private') {
                judge_is_private = 1;
                return false;
            } else {
                judge_is_private = 0;
            }
        });

    }

    // if (is_private) {
    //     console.log('Private Project');
    //     return false;
    // }

    // console.log('is_private', is_private);

    let github1s_input_url;
    let github1s_button_title;
    let github1s_button_title_color;
    let github1s_button_background_color;
    let github1s_target;//default_new_table = 1 eg.<a target='_target'></a>
    let github1s_right_menu;
    let github1s_is_private;
    let github1s_use_gitpod;

    if (input_url !== undefined) {
        github1s_input_url = input_url;
    } else {
        github1s_input_url = default_input_url;
    }

    if (button_title !== undefined) {
        github1s_button_title = button_title;
    } else {
        github1s_button_title = default_button_title;
    }

    if (button_title_color !== undefined) {
        github1s_button_title_color = button_title_color;
    } else {
        github1s_button_title_color = default_button_title_color;
    }

    if (button_background_color !== undefined) {
        github1s_button_background_color = button_background_color;
    } else {
        github1s_button_background_color = default_button_background_color;
    }

    if (use_gitpod !== undefined) {
        github1s_use_gitpod = use_gitpod;
    } else {
        github1s_use_gitpod = default_use_gitpod;
    }

    if (new_tab !== undefined) {
        if (parseInt(new_tab)) {
            github1s_target = '_blank';
        } else {
            github1s_target = '_self';
        }
    } else {
        github1s_target = '_blank';
    }

    if (right_menu !== undefined) {
        github1s_right_menu = right_menu;
    } else {
        github1s_right_menu = default_right_menu;
    }

    if (is_private !== undefined) {
        github1s_is_private = is_private;
    } else {
        github1s_is_private = default_is_private;
    }

    if (github1s_is_private && judge_is_private) {
        return false;
    }

    let href;

    if (github1s_use_gitpod) {
        href = `${github1s_input_url}#${location.href}`;
    } else {
        href = `${github1s_input_url}${location.pathname}`;
    }

    const btn = `
        <a class="btn ml-2 d-none d-md-block" style="background: ${github1s_button_background_color}; color: ${github1s_button_title_color};" target="${github1s_target}" href="${href}">${github1s_button_title}</a>
    `;

    $(btn).insertBefore('.btn.ml-2.d-none.d-md-block');

    console.log('time: ', Date.now());

    if (github1s_right_menu) {
        if (chrome && chrome.contextMenus) {

            chrome.contextMenus.create({
                title: `Open with ${github1s_button_title}`,
                type: 'normal',
                contexts: ['page'],
                onclick: async function (data) {

                    const pageUrl = data['pageUrl'];
                    const tabs = await asyncGetQueryTab();
                    let tab_url

                    if (github1s_use_gitpod) {
                        tab_url = github1s_input_url + '#' + pageUrl;
                    } else {
                        tab_url = pageUrl.replace(/https:\/\/github.com/, github1s_input_url)
                    }

                    if (tabs) {
                        const index = tabs[0]['index'];
                        console.log("index: ", index);
                        chrome.tabs.create({
                            index: index + 1,
                            url: tab_url
                        });
                    } else {
                        chrome.tabs.create({
                            url: tab_url
                        });
                    }
                },
                documentUrlPatterns: ['https://*.github.com/*/*']
            });
        }
    }
}())