function setItem(obj) {
    chrome.storage.sync.set(obj);
    chrome.storage.local.set(obj);
}

function setItemByKey(key, value) {
    let obj = {};
    obj[key] = value;
    chrome.storage.sync.set(obj);
    chrome.storage.local.set(obj);
}

function getItem(obj, callback) {
    chrome.storage.sync.get(obj, callback);
}

function isUrl(url) {
    return /^https?:\/\/(([a-zA-Z0-9]+-?)+[a-zA-Z0-9]+\.)+(([a-zA-Z0-9]+-?)+[a-zA-Z0-9]+)/.test(url);
}

function isHexColor(color) {
    return /^#([a-f0-9]{3,4}|[a-f0-9]{4}(?:[a-f0-9]{2}){1,2})\b$/.test(color);
}

async function asyncGetItem(obj) {
    return new Promise(function (resolve, reject) {
        chrome.storage.sync.get(obj, function (result) {
            if (result) {
                resolve(result[obj]);
            }
            reject(false);
        });
    });
}

async function asyncGetQueryTab() {
    return new Promise(function (resolve, reject) {
        chrome.tabs.query({
            active: true,
            currentWindow: true
        }, (tabs) => {
            if (tabs) {
                resolve(tabs);
            } else {
                reject(false);
            }
        });
    });

}