; (function () {

    init();

    function replace_text(replace_text, find_text) {
        $('.container label').each(function () {
            console.log('label:', $(this).text());
            let text = $(this).text();
            if ($(this).hasClass('Gitpod')) {
                return true;
            }
            let new_text = text.replace(find_text, replace_text);
            $(this).text(new_text);
        });

        let h2_text = $('.container h2').text();

        // $('.container h2').text(h2_text.replace(/find_text/, replace_text));

        $('#button_title').val(replace_text);

    }



    async function init() {

        const default_input_url = 'https://github1s.com';
        const default_gitpod_url = 'https://gitpod.io/';
        const default_button_title = 'Github1s';
        const default_button_title_color = '#ffffff';
        const default_button_background_color = '#2ea44f';
        const default_use_gitpod = 0;
        const default_new_table = 1;
        const default_right_menu = 0;
        const default_is_private = 1;

        let input_url = await asyncGetItem('input_url');
        let button_title = await asyncGetItem('button_title');
        let button_title_color = await asyncGetItem('button_title_color');
        let button_background_color = await asyncGetItem('button_background_color');
        let new_tab = await asyncGetItem('new_tab');
        let right_menu = await asyncGetItem('right_menu');
        let is_private = await asyncGetItem('is_private');
        let use_gitpod = await asyncGetItem('use_gitpod');

        if (input_url !== undefined) {
            $('#input_url').val(input_url);
        } else {
            $('#input_url').val(default_input_url);
        }

        if (button_title !== undefined) {
            $('#button_title').val(button_title);
        } else {
            $('#button_title').val(default_button_title);
        }

        if (button_title_color !== undefined) {
            $('#button_title_color').val(button_title_color);
        } else {
            $('#button_title_color').val(default_button_title_color);
        }

        if (button_background_color !== undefined) {
            $('#button_background_color').val(button_background_color);
        } else {
            $('#button_background_color').val(default_button_background_color);
        }

        if (new_tab !== undefined) {
            if (parseInt(new_tab)) {
                $("#new_tab").prop("checked", true);
            } else {
                $("#new_tab").prop("checked", false);
            }
        } else {
            $("#new_tab").prop("checked", true);
            setItemByKey("new_tab", 1);
        }

        if (right_menu !== undefined) {
            if (parseInt(right_menu)) {
                $("#right_menu").prop("checked", true);
            } else {
                $("#right_menu").prop("checked", false);
            }
        } else {
            $("#right_menu").prop("checked", false);
            setItemByKey("right_menu", 0);
        }

        if (is_private !== undefined) {
            if (parseInt(is_private)) {
                $("#is_private").prop("checked", false);
            } else {
                $("#is_private").prop("checked", true);
            }
        } else {
            $("#is_private").prop("checked", false);
            setItemByKey("is_private", 1);
        }

        if (use_gitpod !== undefined) {
            if (use_gitpod) {
                $("#use_gitpod").prop("checked", true);
                setItemByKey("use_gitpod", 1);
                replace_text('Gitpod', 'GitHub1s');
                $('#input_url').val(default_gitpod_url);
                $('.firt_input').hide();
            } else {
                $("#use_gitpod").prop("checked", false);
                setItemByKey("use_gitpod", 0);
                replace_text('GitHub1s', 'Gitpod');
                $('#input_url').val(default_input_url);
                $('.firt_input').show();
            }
        } else {
            $("#use_gitpod").prop("checked", false);
            setItemByKey("use_gitpod", 0);
            $('.firt_input').hide();
        }


        $("#use_gitpod").on('change', function () {

            let checked = $(this).is(':checked');

            if (checked) {
                setItemByKey("use_gitpod", 1);
                replace_text('Gitpod', 'GitHub1s');
                $('#input_url').val(default_gitpod_url);
                $('.firt_input').hide();
            } else {
                setItemByKey("use_gitpod", 0);
                replace_text('GitHub1s', 'Gitpod');
                $('#input_url').val(default_input_url);
                $('.firt_input').show();
            }
        });


        $("#new_tab").on('change', function () {

            let checked = $(this).is(':checked');

            if (checked) {
                setItemByKey("new_tab", 1);
            } else {
                setItemByKey("new_tab", 0);
            }
        });

        $("#right_menu").on('change', function () {

            let checked = $(this).is(':checked');

            if (checked) {
                setItemByKey("right_menu", 1);
            } else {
                setItemByKey("right_menu", 0);
            }
        });

        $("#is_private").on('change', function () {

            let checked = $(this).is(':checked');

            if (checked) {
                setItemByKey("is_private", 0);
            } else {
                setItemByKey("is_private", 1);
            }
        });

        $('#save_btn').on('click', function () {
            const field_input_url = $('#input_url').val();
            const field_button_title = $('#button_title').val();
            const field_button_title_color = $('#button_title_color').val();
            const field_button_background_color = $('#button_background_color').val();

            if (!isUrl(field_input_url)) {
                alert('Incorrect URL');
                return false;
            }

            if ($.trim(field_button_title) == '') {
                alert('Buttion Title is empty');
                return false;
            }

            if (!isHexColor(field_button_title_color)) {
                alert('Incorrect Title HexColor');
                return false;
            }

            if (!isHexColor(field_button_background_color)) {
                alert('Incorrect Background HexColor');
                return false;
            }

            setItemByKey("input_url", $.trim(field_input_url));
            setItemByKey("button_title", $.trim(field_button_title));
            setItemByKey("button_title_color", $.trim(field_button_title_color));
            setItemByKey("button_background_color", $.trim(field_button_background_color));

            alert('Saved');
        });

        $('#reset_btn').on('click', function () {
            setItemByKey("input_url", $.trim(default_input_url));
            $('#input_url').val(default_input_url)

            setItemByKey("button_title", $.trim(default_button_title));
            $('#button_title').val(default_button_title);

            setItemByKey("button_title_color", $.trim(default_button_title_color));
            $('#button_title_color').val(default_button_title_color);

            setItemByKey("button_background_color", $.trim(default_button_background_color));
            $('#button_background_color').val(default_button_background_color);

            setItemByKey("new_tab", 1);
            $("#new_tab").prop("checked", true);

            setItemByKey("right_menu", 0);
            $("#right_menu").prop("checked", false);

            setItemByKey("is_private", 1);
            $("#is_private").prop("checked", false);

            //use Gitpod
            setItemByKey("use_gitpod", 0);
            $("#use_gitpod").prop("checked", false);
            replace_text('GitHub1s', 'Gitpod');
            $('#input_url').val(default_input_url);
            $('.firt_input').show();

            alert('Reset default settings')

        });

    }
})()